package solution;

public class Roster {
  private Student[] students;
  private int numStudents;

  public Roster(int size) {
    students = new Student[size];
    numStudents = 0;
  }

  public void add(Student s) {
    // stub
  }

  public void remove(Student s) {
    // stub
  }

  // Binary Search
  // Assumption:
  // - students' emails are unique
  // - students array is sorted (based on emails)
  public Student find(String email) {
    // delegate to the helper find method!
    return find(email, 0, numStudents - 1);
  }

  // helper: recursive binary search
  private Student find(String email, int first, int last) {
    // we use first and last indicies to narrow the attention
    // on a portion of the students array. For example:
    // to search only in the first 5 elements: find(email, 0, 6);
    // to search the entire array: find(email, 0, numStudents - 1);

    // base case
    if (last < first) { // no more element to search
      return null; // if we are here, the target is not in this roster
    }

    int mid = (first + last) / 2;

    if (email.compareTo(students[mid].getEmail()) == 0) {
      // found it!
      return students[mid];
    } else if (email.compareTo(students[mid].getEmail()) > 0) {
      // ignore the first half
      // repeat the search for the second half
      // look in the students array but start from mid-point
      return find(email, mid + 1, last);
    } else  {
      // ignore the second half
      // repeat the search for the first half
      // look in the students array from start up to mid-point
      return find(email, first, mid - 1);
    }
  }

/*
 // Linear Search
 // Assumption: students' emails are unique.
 public Student find(String email) {
   // Go over each and every student
   for (int i = 0; i < numStudents; i++) {
     // check if it is what we are looking for
     if (email.equals(students[i].getEmail())) {
       return students[i]; // found it!
     }
   }
   // the target is not in this Roster
   return null;
 }
*/

}
